#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
_Version="1.1.1"
__version__="1.1.1"

_FonctionDuProgramme="Classe accédant aux fichiers et répertoires. "+_Version
_FonctionDuProgramme+="Nécessite les classes re,os,sys\n" 
_importe="re,os,sys"
#print(_FonctionDuProgramme)


"""
110 ajout de ._Fichs ._CFichs ._Reps ._CReps
1.0.9 ajout de CFichiers._RepNomCourt
1.0.8 #self._Fichs=None #self._Reps=None inutiles?
1.0.7 Recursif=True dans CRepertoires.Contenu()
#1.0.6 def Contenu(self): => def Contenu(self,OnGardeLesLiens=False):
"""
#print("version:"+_Version)
#import CFichiersRepertoires
#from CFichiersRepertoires import CFichiersRepertoires,CFichiers


import re
import os
##################### debug
import sys

_debug_Titres=True # 
_debug_Titres=False

_debug_Log=True #
_debug_Log=False

_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug_Log=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+sys.argv[0]+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(ligne):
	if _debug_all==True:
		print(ligne)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

class CFichiersRepertoires(object):
	def __init__(self,_rep=''):
		pass#self._repertoire=_rep
'''
print ( os.path.split('/tmp/bb.jpg') )
('/tmp', 'bb.jpg')
print ( os.path.splitext('/tmp/bb.jpg') )
('/tmp/bb', '.jpg')


print ( os.path.split('/tmp/bb/') )
('/tmp/bb', '')
print ( os.path.splitext('/tmp/bb/') )
('/tmp/bb/', '')



print ( o.split('/tmp/bb') )
('/tmp', 'bb')
print ( os.path.splitext('/tmp/bb') )
('/tmp/bb', '')

'''		
class CFichiers(object):
	""" CLASSE CFichiers(str(fich)) : un fichier """
	def __init__(self,fich=''):
		
		Tprint('fich.__init__()')
		self._SEP='/'	
		self._fich=fich#/tmp/bb.jpg => /tmp/bb.jpg
		
		# fich = _RepNom+"/"+_FichNom = _FichAvantExt + "." + _FichExt
		self._RepNom=self.RepNom()#/tmp/bb.jpg => /tmp
		self._FichNom=self.FichNom()#/tmp/bb.jpg => bb.jpg
		self._FichExt=self.FichExt()#/tmp/bb.jpg => jpg
		self._FichAvantExt=self.FichAvantExt()#/tmp/bb.jpg => /tmp/bb
		self._RepNomCourt=self.RepNomCourt()#/a/tmp/bb.jpg => tmp
		self._FichNomSansExt=self.FichNomSansExt()#/tmp/bb.jpg => bb
		self._NomComplet=self._fich
		
		pass#self._repertoire=_rep
	def Valide(self):
		""" vérifie la validité du fichier """
		Tprint('fich.Valide()')
		resultat=None
		if os.path.isfile(self._fich):
			resultat=True
		if not os.path.isfile(self._fich):
			resultat=False
		return resultat
	def RepNom(self):#/tmp/bb.jpg => /tmp
		Tprint('fich.RepNom()')
		self._RepNom=os.path.split(self._fich)[0]
		return self._RepNom
	def FichNom(self):# /tmp/bb.jpg => bb.jpg
		Tprint('fich.FichNom()')
		self._FichNom=os.path.split(self._fich)[1]
		return self._FichNom
	def FichNomSansExt(self):# /tmp/bb.jpg => bb
		Tprint('fich.FichNomSansExt()')
		#self._FichNomSansExt=re.sub(".*/(.*)\..*","\g<1>",self.FichNom())
		self._FichNomSansExt=re.sub("^(.*)\..*","\g<1>",self.FichNom())
		return self._FichNomSansExt	
	def FichAvantExt(self):# /tmp/bb.jpg => /tmp/bb
		Tprint('fich.FichAvantExt()')
		self._FichAvantExt=os.path.splitext(self._fich)[0]
		return self._FichAvantExt
	def Extension(self):# /tmp/bb.jpg => jpg
		Tprint('fich.Extension()')		
		return self.FichExt()
	def FichExt(self):# /tmp/bb.jpg => jpg
		Tprint('fich.FichExt()')
		self._FichExt=(os.path.splitext(self._fich)[1])[1:]
		return self._FichExt
	def RepNomCourt(self):#/a/tmp/bb.jpg => tmp
		"""#/a/tmp/bb.jpg => tmp"""
		self._RepNomCourt=re.sub(".*/","",self._RepNom)
		return self._RepNomCourt
		
		
	def FichRelativisee(self,rep='/tmp'):
		Tprint('fich.FichRelativisee()')
		rep=CRepertoires(rep)
		self._FichRelativisee=re.sub("^"+rep._rep+"/","",self._fich)
		return self._FichRelativisee



class CExtensions(object):
	def __init__(self,rep=''):
		self._Images=['jpg','jpeg','png','gif','tif','tiff','xcf','psd']
		self._Pdf=self._Ps=['pdf','ps']
		self._Videos=self._Ps=['avi','mov','mpg','mpeg','flv','mp4','ogg','webm']
		self._Programmation=['py','c','cpp','pyc']		
		
		

class CRepertoires(object):
	""" CLASSE CRepertoires(str(fich)) : un répertoire """
	def __init__(self,rep=''):
		self._SEP='/'
		
		self._rep=""
				
		#self._Fichs=None
		self._FichsRec=None
		self._CFichs=None #identique  à self._FichsRec
		self._fichs=[] # noms normaux
		#self._Reps=None
		self._RepsRec=None
		self._CReps=None #identique  à self._RepsRec
		self._reps=[]
		
		
		
		
		
		if isinstance(rep,str):
			while rep[-1]==self._SEP:
				rep=rep[:-1]
			self._rep=rep
			self._recherche=None
		else:
			print("le repertoire appele dans CRepertoires n'est pas un str ",type(rep))
			exit(456456456)
		
		self._RepNom=self.RepNom()#'/tmp'
		self._FichNom=self.FichNom()#rep1
		
	def Valide(self):
		Tprint('rep.Valide()')
		resultat=None
		if os.path.isdir(self._rep):
			resultat=True
		if not os.path.isdir(self._rep):
			resultat=False
		return resultat
		
	#1.0.6def Contenu(self):
	def Contenu(self,Recursif=True,OnGardeLesLiens=False):
		""" on extrait les sous repertoires dans self._RepsRec ; les fichiers dans self._FichsRec ( et return ) """
		Tprint('rep.Contenu()')
		self._FichsRec=[]
		self._RepsRec=[]		
		for root, reps, files in os.walk(self._rep,topdown=True):#1 /tmp/aa ['rep'] ['fade.gif', 'backblue.gif', 'index.html']
			for fich in files: #page038.jpg 
				fullurl = os.path.join(root, fich) #/home/aa/Tome1/page038.jpg				
				#1.0.6 self._FichsRec.append(CFichiers(fullurl))
				if OnGardeLesLiens==True:#on ajoute
					self._FichsRec.append(CFichiers(fullurl))
				elif not os.path.islink(fullurl):#on ne prend pas les liens
					self._FichsRec.append(CFichiers(fullurl))
				#print(fullurl)
			for rep in reps:
				fullurl = os.path.join(root, rep)
				self._RepsRec.append(CRepertoires(fullurl))				 
				#print(fullurl)
			if Recursif==False:
				break	
				
		self._CFichs=self._FichsRec
		self._fichs=[fich._fich for fich in self._CFichs]
		
		self._CReps=self._RepsRec				
		self._reps=[rep._rep for rep in self._CReps]
		
		return self._FichsRec
				
	def RepNom(self):#'/tmp'
		Tprint('rep.RepNom()')
		self._RepNom=os.path.split(self._rep)[0]
		return self._RepNom
		
	def FichNom(self):#rep1
		Tprint('rep.FichNom()')
		self._FichNom=os.path.split(self._rep)[1]
		return self._FichNom
		
	def ChercheFichiersAvecExtension(self,ext='pdf'):#retourne list(CFichiers)
		Tprint('fich.ChercheFichierAvecExtension(ext)')
		if self._FichsRec==None:
			self.Contenu()
		self._recherche=[fich for fich in self._FichsRec if ext in fich.FichExt().lower()]	
		return self._recherche
		
	def ChercheFichiersAvecNom(self,NOMs,PasDeCasse=True,Operation='AND'):#retourne list(CFichiers)
		Tprint('fich.ChercheFichierAvecNom(ext)')		
		if self._FichsRec==None:
			self.Contenu()		
		
		if str(type(NOMs))=="<class 'str'>":	
			NOMs=[NOMs]				
		if PasDeCasse==True:
			NOMs=[nom.lower() for nom in NOMs]
			if Operation=="OR":
				self._recherche=[fich for fich in self._FichsRec if any(nom in fich._fich.lower() for nom in NOMs)]
			else:
				Operation=="AND"
				self._recherche=[fich for fich in self._FichsRec if all(nom in fich._fich.lower() for nom in NOMs)]	
		else:
			if Operation=="OR":
				self._recherche=[fich for fich in self._FichsRec if any(nom in fich._fich for nom in NOMs)]
			else:
				Operation=="AND"
				self._recherche=[fich for fich in self._FichsRec if all(nom in fich._fich for nom in NOMs)]	
			
		return self._recherche	
'''				
	tmps=[]
############"# PDFs
#p1 = Popen(['find', '/home/bruno/Bureau/MATHS/', '-name', '*pdf', '-type', 'f'], stdout=PIPE)
p1 = Popen(['find', repertoire, '-name', '*pdf', '-type', 'f'], stdout=PIPE)

tmp=p1.communicate()[0]
tmps.append(tmp)				
'''

#self.thumbs=os.listdir(rep)
#(os.path.splitext(i)[1])[1:]
#self.thumbs=[ i for i in self.thumbs if ((os.path.splitext(i)[1])[1:]).lower() in SuffixesImages ]		#AfficheImagesAvecLegendes

	
global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)


	print('import CFichiersRepertoires')
	print('from CFichiersRepertoires import CRepertoires,CFichiers')
	print('fich=CFichiers(nomfich)')
	print('  fich._SEP')
	print('  fich._fich , fich.Valide() , fich.RepNom() ,	fich.FichNom() , FichExt  .FichAvantExt')
	print('rep=CRepertoires(nomrep)')
	print('  rep._SEP , rep.Contenu() ')
	print('  rep._rep , rep.Valide() , rep.RepNom() ,	rep.FichNom() self.FichAvantExt')
	
	print('Ext=CExtensions()')
	print("		Ext._Images=['jpg','jpeg','png','gif','tif','tiff','xcf','psd'] \n\
		Ext._Pdf=self._Ps=['pdf','ps'] \n\
		Ext._Videos=self._Ps=['avi','mov','mpg','mpeg','flv','mp4','ogg','webm'] \n\
		Ext._Programmation=['py','c','cpp','pyc'] \n\
		rep.ChercheFichierAvecNom(['s-mathematiques-obligatoire-2016-metropole-suj','/ES'],PasDeCasse=False,Operation='OR')\n\
		")
	rep=CRepertoires('/tmp/ANNALES')
	#rep.ChercheFichierAvecExtension('pdf')
	rep.ChercheFichiersAvecNom(['s-mathematiques-obligatoire-2016-metropole-suj','/ES'],PasDeCasse=False,Operation="AND")
	print([f._fich for f in rep._recherche])
	
	
	
	
	
	
	nom='/tmp/aa/bb/cc/dd/ee/ff/gg/bb.jpg'
	a=CFichiers(nom)
	print("CFichiers("+nom+")._FichExt = "+a._FichExt)
	
	
	
	print("CFichiers("+nom+").FichRelativisee('/tmp/aa/bb') = "+CFichiers(nom).FichRelativisee("/tmp/aa/bb"))
	
	
	print(a.__doc__)
	
	sys.exit()


