#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function

import sys
import re
_FonctionDuProgramme=re.sub(".*/","",sys.argv[0])
_FonctionDuProgramme+="\n\
_FonctionDuProgramme\
\
"

#apt-get install python-numpy  python-numpy python-matplotlib
import numpy as np
from matplotlib import pyplot as plt


#print(_FonctionDuProgramme)
_Version="1.0"
__version__=_Version


#print("version:"+_Version)
_FonctionDuProgramme+="\n\
Version:"+_Version+"\n"
'''
dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
'''

import os
##################### debug

_debug=True # _debug=False

_debug_Titres=True # _debug_Titres=False

_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug=True

_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(*args, **kwargs):
	if _debug==True:
		print('==========================Dprint')
		print(sys.argv[0],*args, **kwargs)					
		print(sys.argv[0],*args,file=_Log)
		print('  =  =  =  =  =  =  =  =')
# # # # # # # # # # # # # # # # # # # debug
# ajout de doc + Tprint sed -e 's/^\(.*\)\(def\ \)\(.*\)$/\1\2\3\n\1\t"""-*\3"""\n\1\tTprint("\3")/' -i aa.py
class br_CDict(dict):
	def __init__(self,retour=""):
		self._retour=retour
	def __missing__(self, key):
		return self._retour
		
class br_CDICO(dict):
	def __missing__(self, key):
		return None

DicoFonctions=br_CDICO()
DicoClasses=br_CDICO()

def CreeFonction(duree=10.0,Echantillonnage=44100.0):
	''' cree une fonction '''
	N=int(duree * Echantillonnage)+1
	t=np.arange(0,N)/Echantillonnage
	duree=N/Echantillonnage
	
	f0 = 100
	init=2*np.cos(2*np.pi * t *f0)+3*2*np.cos(2*np.pi * t *f0*2)
	return init
	
	
def TransformeeDeFourier(a):
	b=np.fft.fft(a) # 0.1.2.3 4 [5] -5 -4 -3 -2 -1
	#b=np.fft.fftshift(b) # -5 -4 -3 -2 -1  0.1.2.3 4 [5]
	return b

def FreqAmplitude(a,Echantillonnage=44100.0,eps=0.01):

	b=np.fft.fft(a)# 0.1.2.3 4 [5] -5 -4 -3 -2 -1
	b=np.fft.fftshift(b)# -5 -4 -3 -2 -1  0.1.2.3 4 [5]
	b=np.abs(b)
	eps=max(b)*eps
	N=len(a)
	if N%2==0:
		_FreqAmplitude=[((no-N/2)*Echantillonnage/N,b0) for no,b0 in enumerate(b) if b0>eps]
	else:
		_FreqAmplitude=[((no-(N-1)/2)*Echantillonnage/N,b0) for no,b0 in enumerate(b) if b0>eps]
	return _FreqAmplitude

def TransformeeDeFourierInverse(b):
	c=np.fft.ifft(b)
	return c

FreqAmplitude(CreeFonction())	
"""

	plt.figure()
plt.subplot(121)
plt.plot(t,init,'-')
plt.plot(t,init,'r-')
plt.xlabel('axe temporel init, en seconde')


plt.subplot(122)
#plt.plot(axe_f,np.abs(b),'x-')
plt.plot(axe_f,c,'x-')
plt.xlabel('axe frequentiels en Hertz')

plt.show()


B=sorted( FreqAmplitude , key=lambda tabl: -tabl[1] )

print(B[0:10])
"""
