from __future__ import print_function
# -*- coding: utf-8 -*-
_FonctionDuProgramme="_FonctionDuProgramme"
print(_FonctionDuProgramme)


_Version="1.0.0"
__version__="1.0.0"
print("Version:"+_Version)


#dossier="/home/bruno/Bureau/PROGRAMMATION/PYTHON/CLASSES"
dossier="/opt/CLASSES"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    
import re


"""
import CFonctions
from CFonctions import TableauToString
from CFonctions import *
	# TableauToString(tablo,sep="")
	# HexsInt(hexa,N=1)HexInt(hexa)
	# EstUnEntier(obj), EstUnReel(obj), EstUnTuple(obj)

import CFichiersRepertoires
from CFichiersRepertoires import CRepertoires,CFichiers,CExtensions
CRepertoires().Contenu() == [ Cfichiers(fullurl) ]

	
		
import CFichierContenu
from CFichierContenu import CExtensions,CFichierContenu
'DecoupeEnDeux', 'EcritFichier', 'FermeFichier', 'Lignes', 'Lignes0', 'OuvreFichier', 'TrouveIntervalleEnLignes', 'UneLigne', 'UneLigne2', '_Lignes'


import CBaseDeDonnees
from CBaseDeDonnees import CBaseDeDonnees

import br_BASH
FBash3('mkdir -p a_fichiers/')")
A privilégier si pipe: FBashPipes(['ls -al a_fichiers/','grep usr'])
	
import CTris
import br_CLASSE_wave
import CFichiersRepertoires-V1.0.3
import CGeometrie
import CDictionnaire

import br_CFonction_Graphiques-tk

import CMatrixMatrices
"""




##################### debug


_debug_Titres=True #_debug_Titres=False
_debug_all=True # 
_debug_all=False


if _debug_all==True:
	_debug_Titres=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+re.sub('.*/','',sys.argv[0])+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def dprint(ligne):
	if _debug==True:
		print(ligne)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

class CProjetDePo(object):
	def __init__(self,_rep=''):
		self._repertoire=_rep

if _debug_Titres==True:
	_Log.close()
xrange=range


def acceleration1(t,x,v):
	return -x

def ressort(t,x,v,donnees={"k":None,"w":10.0,"m":None}):
	w=donnees["w"]
	return -w**2 * x

def gravitation1(t,x,v,donnees={"g":-9.81,}):
	g=donnees["g"]
	return g


def harmoeuler(h,T,t0,x0,v0,acc=ressort):
	"""harmoeuler(h=pas,T=temps de calcul,t0=heure intiale,x0=position initiale,v0=vitesse initiale,acc=ressort):"""
	'''
	v[k+1]=v[k]-dt*x[k]
	x[k+1]=x[k]+dt*v[k]
	t[k+1]=t[k]+dt
	h=dt
	'''
	x=[x0]
	v=[v0]
	t=[t0]
	N=int(T/h)	
	
	for k in xrange(N):
		#v.append(v[k]-h*x[k])
		v.append(v[k] + h * acc(t[k],x[k],v[k]) )
		x.append(x[k]+h*v[k])
		t.append(t[k]+h)
	return t,x,v


def harmoheun(h,T,t0,x0,v0,acc=ressort):	
	'''
	v[k+1]=v[k]+.5*(-h*x[k]+-h*(x[k]+b1))
	x[k+1]=x[k]+.5*(h*v[k]+h*(v[k]+-h*x[k]))
	t[k+1]=t[k]+h
	h=dt
	'''
	x=[x0]
	v=[v0]
	t=[t0]
	N=int(T/h)
	
	
	for k in xrange(N):
		"""
		a1=-h*x[k]
		b1=h*v[k]
		a2=-h*(x[k]+b1)
		b2=h*(v[k]+a1)
		v.append(v[k]+.5*(a1+a2))
		x.append(x[k]+.5*(b1+b2))
		t.append(t[k]+h)
		"""
		
		dv1 = h*acc(t[k],x[k],v[k])  #-h*x[k] # dv1 = -w**2.x.dt
		dx1 = h*v[k] # dx1 = v.dt
		dv2 = h*acc(t[k],x[k]+dx1,v[k])#-h*(x[k]+dx1) # dv2 = -w**2.dt.(x+dx1)
		dx2 = h*(v[k]+dv1) # dx2 = (v+dv1).dt
		v.append(v[k]+.5*(dv1+dv2))
		x.append(x[k]+.5*(dx1+dx2))
		t.append(t[k]+h)
		
		
	return t,x,v

def harmoRK4(h,T,t0,x0,v0,acc=ressort):	
	'''
	v[k+1]=v[k]+(-h*x[k]+2*-h*(x[k]+h*v[k]/2.)+2*-h*(x[k]+h*(v[k]+-h*x[k]/2.)/2.)+-h*(x[k]+h*(v[k]+-h*(x[k]+h*v[k]/2.)/2.)))/6.
	v[k+1]=v[k]+x[k] * h * (-2 +h**2.0 )  +v[k] * h**2 * (-3 +h**2.0 / 4. ) 
	x[k+1]=x[k]+(h*v[k]+2*h*(v[k]+-h*x[k]/2.)+2*h*(v[k]+-h*(x[k]+h*v[k]/2.)/2.)+h*(v[k]+-h*(x[k]+h*(v[k]+-h*x[k]/2.)/2.)))/6.
	t[k+1]=t[k]+h
	h=dt
	'''	
	x=[x0]
	y=[x0]
	v=[v0]
	w=[v0]
	t=[t0]
	N=int(T/h)	
	"""for k in xrange(N):
		a1=-h*x[k]
		b1=h*v[k]
		a2=-h*(x[k]+b1/2.)
		b2=h*(v[k]+a1/2.)
		a3=-h*(x[k]+b2/2.)
		b3=h*(v[k]+a2/2.)
		a4=-h*(x[k]+b3)
		b4=h*(v[k]+a3)
		w.append(w[k]+( h* (  -1. +h*h /6.  ) *y[k]  + h*h *(  -0.5  +h*h/24. )*w[k] ))
		v.append(v[k]+(a1+2*a2+2*a3+a4)/6.)
		y.append(y[k]+(h*h*(-0.5 +h*h/24. )*y[k] + h*(1.0-h*h/6.0)*w[k] ) )		
		x.append(x[k]+(b1+2*b2+2*b3+b4)/6.)
		t.append(t[k]+h)
	"""	
		
	for k in xrange(N):
		dv1= h * acc(t[k],x[k],v[k]) #-h*x[k]
		dx1=h*v[k]
		dv2= h * acc(t[k],x[k]+dx1/2.,v[k]) # -h*(x[k]+dx1/2.)
		dx2=h*(v[k]+dv1/2.)
		dv3= h * acc(t[k],x[k]+dx2/2.,v[k])  #-h*(x[k]+dx2/2.)
		dx3=h*(v[k]+dv2/2.)
		dv4= h * acc(t[k],x[k]+dx3,v[k])#-h*(x[k]+dx3)
		dx4=h*(v[k]+dv3)
		v.append(v[k]+(dv1+2*dv2+2*dv3+dv4)/6.)
		x.append(x[k]+(dx1+2*dx2+2*dx3+dx4)/6.)
		t.append(t[k]+h)	
 
	return t,x,v#,w,y

def harmoeulerimpl(h,T,t0,x0,v0,acc=ressort):	
	x=[x0]
	v=[v0]
	t=[t0]
	N=int(T/h)	

	for k in xrange(N):
		#v.append((v[k]-h*x[k])/(1.+h**2.))
		v.append((v[k] + h *  acc(t[k],x[k],v[k])   )/(1.+h**2.))
		
		x.append((x[k]+h*v[k])/(1.+h**2.))
		t.append(t[k]+h)

	return t,x,v

def ZZZharmocrank(h,T,t0,x0,v0):	
	x=[x0]
	v=[v0]
	t=[t0]
	N=int(T/h)	

	for k in xrange(N):

		v.append((-x[k]*h+(1.-h**2./4.)*v[k])/(1.+h**2./4.))

		x.append((v[k]*h+(1.-h**2./4.)*x[k])/(1.+h**2./4.))
		t.append(t[k]+h)

	return t,x,v


import matplotlib.pyplot as plt 

def graphique(x,v,t):

	E=[.5*(x[i]**2.+v[i]**2.) for i in xrange(len(x))]
	
	fig,ax=plt.subplots()
	fig,((ax1,ax2),(ax3,ax4))=\
	plt.subplots(nrows=2,ncols=2)
	   
	ax1.plot(t,x,'k')
	ax1.set_xlabel('temps',fontsize=14)
	ax1.set_ylabel('position',fontsize=14)

	ax2.plot(t,v,'k')
	ax2.set_xlabel('temps',fontsize=14)
	ax2.set_ylabel('vitesse',fontsize=14)

	ax3.plot(t,E,'k')
	ax3.set_xlabel('temps',fontsize=14)
	ax3.set_ylabel(u'énergie',fontsize=14)

	ax4.plot(x,v,'k')
	ax4.set_xlabel('position',fontsize=14)
	ax4.set_ylabel('vitesse',fontsize=14)
	ax4.axis('equal')

	plt.tight_layout()
	plt.show()



'''t,x,v,w,y=harmoRK4(0.2,100,0,1,0)
for i in range(len(v)):
	print(x[i]-y[i])
'''
#t,x,v=harmoeuler(0.1,100,0,1,10)
#t,x,v=harmoheun(0.002,100,0,1,200)
#t,x,v=harmoRK4(0.2,100,0,1,0,gravitation1)
t,x,v=harmoeulerimpl(0.001,100,0,1,10)

graphique(x,v,t)
print('fini')


exit(0)

#from harmonique import *

t,x,v=harmoeuler(0.2,100,0,1,0)
graphique(x,v,t)

'''
t,x,v=harmoheun(0.2,100,0,1,0)
graphique(x,v,t)

t,x,v=harmoRK4(0.2,100,0,1,0)
graphique(x,v,t)

t,x,v=harmoeulerimpl(0.2,100,0,1,0)
graphique(x,v,t)

t,x,v=harmocrank(0.2,100,0,1,0)
graphique(x,v,t)
'''

from numpy import cos,log,polyfit
#from harmonique import *
import matplotlib.pylab as plt

T=12
ee=[];eh=[];er=[];eei=[];ec=[]
pas=[]
for i in xrange(1,310):
	h=1./(5.*i)
			
	t,xe,ve=harmoeuler(h,T,0,1,0)
	Ee=[abs(xe[i]-cos(t[i])) for i in xrange(len(t))]
	ee.append(log(max(Ee)))
	
	
	'''
	xh=harmoheun(h,T,0,1,0)[1]
	Eh=[abs(xh[i]-cos(t[i])) for i in xrange(len(t))]
	eh.append(log(max(Eh)))
	
	xr=harmoRK4(h,T,0,1,0)[1]
	Er=[abs(xr[i]-cos(t[i])) for i in xrange(len(t))]
	er.append(log(max(Er)))
	
	xei=harmoeulerimpl(h,T,0,1,0)[1]
	Eei=[abs(xei[i]-cos(t[i])) for i in xrange(len(t))]
	eei.append(log(max(Eei)))
	
	xc=harmocrank(h,T,0,1,0)[1]
	Ec=[abs(xc[i]-cos(t[i])) for i in xrange(len(t))]
	ec.append(log(max(Ec)))
	'''
	
	
	pas.append(log(h))

''''
plt.plot(pas,ee,'-k',pas,\
eei,'-.k',pas,eh,'--k',\
pas,ec,'.:k',pas,er,'+:k')
'''

plt.plot(pas,ee,'-k')

plt.legend(('Euler explicite','Euler implicite',\
	'Heun','Crank','RK4'),0);

plt.xlabel('ln(h)',fontsize=14)
plt.ylabel('ln(' r"$\epsilon$" ')',fontsize=14)

plt.show()

print (polyfit(pas,ee,1))

'''
print (polyfit(pas,eh,1))
print (polyfit(pas,er,1))
print (polyfit(pas,eei,1))
print (polyfit(pas,ec,1))
'''
